/* This program is designed to cooperate with the
   shellscripts lstviewd.cgi and mstviewd.cgi and
   helps speed up operations that were formerly
   done with tools like sed, awk etc.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int ProcessLine (char *buf, int includedate);
int ProcessDate (char *buf);

int main (int argc, char **argv)
{
   static char buf[512];
   int includedate = 0;

   if (argc > 1 && strcmp(argv[1], "-d") == 0)
      includedate = 1;

   while (fgets(buf, sizeof buf, stdin))
   {
      ProcessLine(buf, includedate);
   }

   return 0;
}

int ProcessLine (char *buf, int includedate)
{
   char *StartUrl = NULL, *EndUrl = NULL, *p = NULL;

   if (!(p = strstr(buf, "\"GET /")))
   if (!(p = strstr(buf, "\"HEAD /")))
   if (!(p = strstr(buf, "\"POST /")))
   {
      /* None of the interesting stuff found, so skip
         and ignore the whole line.
         This replaces the functionality of egrep in
         the shell script. */
      return 0;
   }
   StartUrl = strstr(p, " /") + 2;

   p = strstr(StartUrl, " HTTP/1.1\"");
   if (!p)
      p = strstr(StartUrl, " HTTP/1.0\"");

   if (p)
      EndUrl = p;

   if (StartUrl && EndUrl && EndUrl > StartUrl)
   {
      int len = EndUrl - StartUrl;

      if (includedate)
         ProcessDate(buf);

      printf("[%*.*s]\n", len, len, StartUrl);
   }

   return 0;
}

int ProcessDate (char *buf)
{
   char *StartBrace = NULL, *p = NULL, *q = NULL;
   int DayDate = 0;
   int len = 8;

   /* Looking for something like this
      [19/Nov/2011:15:48:39 +0000] */
   StartBrace = strchr(buf, '[');
   if (!StartBrace)
   {
      printf("[00:00:00 - 00]   ");
      return 0;
   }

   DayDate = strtol(StartBrace + 1, NULL, 10);

   /* Wanted output is:
      "[15:48:39 - 19]   " */

   p = strchr(StartBrace + 3, ':');
   if (p)
   {
      p++;
      q = strchr(p, ' ');
   }
   if (p && q)
      len = q - p;

   printf("[%*.*s - %2d]   ", len, len, p && q ? p : "00:00:00", DayDate);

   return 0;
}
